unit FGuiClient;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, Vcl.Buttons, Vcl.StdCtrls, Vcl.ExtCtrls,
  Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    IdTCPClient1: TIdTCPClient;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    Timer1: TTimer;
    RichEdit1: TRichEdit;
    procedure SpeedButton1Click(Sender: TObject);
    procedure IdTCPClient1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: string);
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure Log(Msg: string; col:Tcolor);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure ColLog(aEdit:TRichEdit; aMsg:string; aColor:TColor; // no form copnnction - library function
                  UpdateNow:boolean=false; Limitlines:boolean=true);
var h,fh:integer;
begin
  for h:=1 to length(aMsg) do if not (charinset(aMsg[h],[#32..#127])) then aMsg[h]:='|';
  aEdit.CaretPos:=point(0,aEdit.lines.count);
  aEdit.SelAttributes.Color:=aColor;  aEdit.Lines.add(aMsg);
  h:=aEdit.ClientHeight; if h<26 then h:=26; fh:= abs(aEdit.Font.Height)+3;
  if limitlines then while aEdit.lines.count >= h div fh {14} do aEdit.Lines.Delete(0);
  if UpdateNow  then aEdit.Update;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  Try
  if not IdTCPClient1.Connected then raise Exception.Create('First make connection');
  IdTCPClient1.Socket.Write(Key);
  except
    on e: exception do log(e.Message,Clred)
  end
end;

procedure TForm1.IdTCPClient1Connected(Sender: TObject);
begin
  log('Connected', clgreen);
end;

procedure TForm1.IdTCPClient1Status(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: string);
begin
  log(AStatusText,clred)
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if SpeedButton1.Down then

  IdTCPClient1.Connect
  else IdTCPClient1.DisConnect ;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
Var Cnt :integer;
    c: Char;
begin
  try
    if IdTCPClient1.Connected then
    begin
      while not IdTCPClient1.IOHandler.InputBufferIsEmpty   do
      begin
        C:= (Char(IdTCPClient1.IOHandler.ReadByte)) ;
        if C= #13
        then  RichEdit1.lines.add('')
        else  RichEdit1.Text := RichEdit1.Text + C;
      end;
    end;
  except
    on e: exception do log(e.Message,Clred)
  end;

end;

procedure TForm1.Log(Msg: string; col:Tcolor);
begin
  Collog(RichEdit1,Msg,Col);
end;

end.
